      SUBROUTINE INIRAC
      REAL*8 FACLOG(500),FN
      COMMON /CLEBMA/FACLOG
      FACLOG(1)=0.0D0
      FACLOG(2)=0.0D0
      FN=1.D0
      DO 200 I=3,500
      FN=FN+1.0D0
  200 FACLOG(I)=FACLOG(I-1)+DLOG(FN)
      RETURN
      END

      REAL*8 FUNCTION  CLEB(IA,ID,IB,IE,IC,IF)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/CLEBMA/FACLOG(500)
C
   10 CLEB=0.0D0
      IF(ID+IE-IF) 7000,105,7000
  105 K1=IA+IB+IC
      IF((-1.)**K1) 7000,110,110
  110 K1=IA+IB-IC
      K2=IC-IABS(IA-IB)
      K3=MIN0(K1,K2)
      IF(K3) 7000,130,130
  130 IF((-1.)**(IB+IE)) 7000,7000,140
  140 IF((-1.)**(IC+IF)) 7000,7000,150
  150 IF(IA-IABS (ID)) 7000,152,152
  152 IF(IB-IABS (IE)) 7000,154,154
  154 IF(IC-IABS (IF)) 7000,160,160
  160 IF(IA) 7000,175,165
  165 IF(IB) 7000,175,170
  170 IF(IC) 7000,180,250
  175 CLEB=1.0D0
      GO TO 7000
  180 FB=IB+1
      CLEB=((-1.0D0)**((IA-ID)/2))/DSQRT(FB)
      GO TO 7000
  250 FC2=IC+1
      IABCP=(IA+IB+IC)/2+1
      IABC=IABCP-IC
      ICAB=IABCP-IB
      IBCA=IABCP-IA
      IAPD=(IA+ID)/2+1
      IAMD=IAPD-ID
      IBPE=(IB+IE)/2+1
      IBME=IBPE-IE
      ICPF=(IC+IF)/2+1
      ICMF=ICPF-IF
      SQFCLG=0.5D0*(DLOG(FC2)-FACLOG(IABCP+1)
     1      +FACLOG(IABC)+FACLOG(ICAB)+FACLOG(IBCA)
     2      +FACLOG(IAPD)+FACLOG(IAMD)+FACLOG(IBPE)
     3      +FACLOG(IBME)+FACLOG(ICPF)+FACLOG(ICMF))
      NZMIC2=(IB-IC-ID)/2
      NZMIC3=(IA-IC+IE)/2
      NZMI= MAX0 (0,NZMIC2,NZMIC3)+1
      NZMX= MIN0 (IABC,IAMD,IBPE)
      IF(NZMX.LT.NZMI) GO TO 7000
      S1=(-1.0D0)**(NZMI-1)
      DO 400 NZ=NZMI,NZMX
      NZM1=NZ-1
      NZT1=IABC-NZM1
      NZT2=IAMD-NZM1
      NZT3=IBPE-NZM1
      NZT4=NZ-NZMIC2
      NZT5=NZ-NZMIC3
      TERMLG=SQFCLG-FACLOG(NZ)-FACLOG(NZT1)-FACLOG(NZT2)
     1           -FACLOG(NZT3)-FACLOG(NZT4)-FACLOG(NZT5)
      SSTERM=S1*DEXP(TERMLG)
      CLEB=CLEB+SSTERM
  400 S1=-S1
C
 7000 RETURN
      END

      REAL*8 FUNCTION CLEBZ(L1CL,L2CL,L3CL)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/CLEBMA/FACLOG(500)
      LSUM=(L1CL+L2CL+L3CL)/2
   12 LG=LSUM/2
      IF(2*LG-LSUM) 15,20,20
   15 CLEBZ=0.D0
      GO TO 60
   20 L1=LSUM-L1CL
      L2=LSUM-L2CL
      L3=LSUM-L3CL
      IF(MIN0(L1,L2,L3)) 15,22,22
   22 FACT1=DSQRT(DFLOAT(L3CL+1))
      LX=L3CL/2+LG
      IF(2*(LX/2)-LX) 30,32,32
   30 FACT1=-FACT1
   32 L12=L1/2+1
      L22=L2/2+1
      L32=L3/2+1
      H1=0.5D0*(FACLOG(L1+1)+FACLOG(L2+1)+FACLOG(L3+1)-FACLOG(LSUM+2))+
     1FACLOG(LG+1)-FACLOG(L12)-FACLOG(L22)-FACLOG(L32)
      CLEBZ=FACT1*DEXP(H1)
   60 RETURN
      END

      REAL*8 FUNCTION RAC(IA,IB,IC,ID,IE,IF)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/CLEBMA/FACLOG(500)
      DIMENSION  LT(6)
C
   10 RAC=0.0D0
      K1=IA+IB-IE
      K2=IE-IABS (IA-IB)
      K3=IC+ID-IE
      K4=IE-IABS (IC-ID)
      K5=IA+IC-IF
      K6=IF-IABS (IA-IC)
      K7=IB+ID-IF
      K8=IF-IABS(IB-ID)
      K9= MIN0 (K1,K2,K3,K4,K5,K6,K7,K8)
      IF(K9) 7000,20,20
   20 K2=K1-2*(K1/2)
      K4=K3-2*(K3/2)
      K6=K5-2*(K5/2)
      K8=K7-2*(K7/2)
      IF(MAX0(K2,K4,K6,K8)) 7000,25,7000
   25 LTMIN=MIN0(IA,IB,IC,ID,IE,IF)
      IF(LTMIN) 7000,30,150
   30 LT(1)=IA
      LT(2)=IB
      LT(3)=IC
      LT(4)=ID
      LT(5)=IE
      LT(6)=IF
      LTMIN=LT(1)
      KMIN=1
      DO 40 N=2,6
      IF(LT(N)-LTMIN) 35,40,40
   35 LTMIN=LT(N)
      KMIN=N
   40 CONTINUE
      S1=1.0D0
      F1=IE
      F2=IF
      GO TO (55,55,55,55,45,50),KMIN
   45 F1=IA
      F2=IC
      S1=(-1.0D0)**(K5/2)
      GO TO 55
   50 F1=IA
      F2=IB
      S1=(-1.0D0)**(K1/2)
   55 RAC=S1/DSQRT((F1+1.D0)*(F2+1.D0))
      GO TO 7000
  150 IABEP=(IA+IB+IE)/2+1
      ICDEP=(IC+ID+IE)/2+1
      IACFP=(IA+IC+IF)/2+1
      IBDFP=(IB+ID+IF)/2+1
      IABE=IABEP-IE
      IEAB=IABEP-IB
      IBEA=IABEP-IA
      ICDE=ICDEP-IE
      IECD=ICDEP-ID
      IDEC=ICDEP-IC
      IACF=IACFP-IF
      IFAC=IACFP-IC
      ICFA=IACFP-IA
      IBDF=IBDFP-IF
      IFBD=IBDFP-ID
      IDFB=IBDFP-IB
      IABCD1=(IA+IB+IC+ID+4)/2
      IEFMAD=(IE+IF-IA-ID)/2
      IEFMBC=(IE+IF-IB-IC)/2
      NZMAX=MIN0(IABE,ICDE,IACF,IBDF)
      NZMI1=-IEFMAD
      NZMI2=-IEFMBC
      NZMIN=MAX0(0,NZMI1,NZMI2)+1
      IF(NZMAX.LT.NZMIN) GO TO 7000
  180 SQLOG=FACLOG(IABE)+FACLOG(IEAB)+FACLOG(IBEA)+FACLOG(ICDE)+FACLOG(I
     1ECD)+FACLOG(IDEC)+FACLOG(IACF)+FACLOG(IFAC)+FACLOG(ICFA)+FACLOG(IB
     2DF)+FACLOG(IFBD)+FACLOG(IDFB)-FACLOG(IABEP+1)-FACLOG(ICDEP+1)-FACL
     3OG(IACFP+1)-FACLOG(IBDFP+1)
      SQLOG=0.5D0*SQLOG
      DO 200 NZ=NZMIN,NZMAX
      NZM1=NZ-1
      K1=IABCD1-NZM1
      K2=IABE-NZM1
      K3=ICDE-NZM1
      K4=IACF-NZM1
      K5=IBDF-NZM1
      K6=NZ
      K7=IEFMAD+NZ
      K8=IEFMBC+NZ
      SSLOG=SQLOG+FACLOG(K1)-FACLOG(K2)-FACLOG(K3)-FACLOG(K4)
     1           -FACLOG(K5)-FACLOG(K6)-FACLOG(K7)-FACLOG(K8)
      SSTERM=((-1.0D0)**NZM1)*DEXP(SSLOG)
      RAC=RAC+SSTERM
  200 CONTINUE
 7000 RETURN
      END

      REAL*8 FUNCTION  U9(JA,JB,JC,JD,JE,JF,JG,JH,JI)
      IMPLICIT REAL*8 (A-H,O-Z)
C     ALL L9 MUST BE TWICE THAT OF USUAL J
C
      U9=0.0D0
      K1=IABS(JB-JG)
      K2=IABS(JC-JE)
      K3=IABS(JD-JI)
      MINRDA=MAX0(K1,K2,K3)
      K1=JB+JG
      K2=JC+JE
      K3=JD+JI
      MAXRDA=MIN0(K1,K2,K3)
      IF(MINRDA-MAXRDA) 30,30,20
   20 GO TO 7000
   30 DO 50 N1=MINRDA,MAXRDA,2
      RAMDA2=N1
      U9=U9+(RAMDA2+1.0D0)*RAC(JB,JE,JG,JC,JA,N1)*RAC(JB,JD,JG,JI,JH,N1)
     1                  *RAC(JC,JD,JE,JI,JF,N1)
   50 CONTINUE
 7000 RETURN
      END
