      subroutine spline(nR,dR,f,fp0,fpn)
      implicit none
      include 'parameter.f'
      integer  nR,nR0
      real*8   dR,dR0,f(0:nR),fp0,fpn
      integer  iR
      real*8   sig,q,qn,gn,g(0:nRmax),fa(0:nRmax),f2(0:nRmax)
      parameter (sig=0.5D0)
      common /splcom/fa,f2,dR0,nR0
      if (nR.gt.nRmax) pause 'Too large array for "spline".'
      if (fp0.gt.0.99D30) then	! üǡּפʶ
         f2(0)=0.D0
         g (0)=0.D0
      else			! Ϳ줿쳬Ƴؿͤˤ
         f2(0)=-0.5D0
         g (0)=(3.D0/dR)*((f(1)-f(0))/dR-fp0)
      endif
      do iR=1,nR-1
         q     =sig*f2(iR-1)+2.D0
         f2(iR)=(sig-1.D0)/q
         g (iR)=(6.D0*(f(iR+1)-2.D0*f(iR)+f(iR-1))/(2.D0*dR**2)
     &           -sig*g(iR-1))/q
      enddo
      if (fpn.gt.0.99D30) then	! üǡּפʶ
         qn=0.D0
         gn=0.D0
      else			! Ϳ줿쳬Ƴؿͤˤ
         qn=0.5D0
         gn=(3.D0/dR)*(fpn-(f(nR)-f(nR-1))/dR)
      endif
      f2(nR)=(gn-qn*g(nR-1))/(qn*f2(nR-1)+1.D0)
      do iR=nR-1,0,-1
         f2(iR)=f2(iR)*f2(iR+1)+g(iR)
      enddo
      nR0=nR
      dR0=dR
      do iR=0,nR
         fa(iR)=f(iR)
      enddo
      return
      end

      real*8 function splint(R)
      implicit none
      include 'parameter.f'
      integer  nR,khi,klo
      real*8   dR,R,f(0:nRmax),f2(0:nRmax),a,b
      common /splcom/f,f2,dR,nR
      splint=0.D0
      klo=int(R/dR)
      khi=klo+1
      if (klo.ge.nR) return
      a=dble(khi)-R/dR
      b=R/dR-dble(klo)
      splint=a*f(klo)+b*f(khi)
     &      +((a*a-1.D0)*a*f2(klo)+(b*b-1.D0)*b*f2(khi))*(dR**2)/6.D0
      return
      end
