      implicit real*8(a-h,k,m,o-z)
      include 'parameter.f'
      parameter (mu=931.494*(1.007275+1.008665)/2.)
      parameter (hc=197.32705, e2=hc/137.036)
      parameter (nR=150, dR=0.1, Lmax=70)
      complex*16 chi(0:nRmax,-1:1,0:Lmax0)
      real*8     sigma(0:Lmax0)
      character  fmt*20,flname*40
      read(5,*) A,Z,mp,Zp,IS,Elab
      write(0,*) 'A,Z,mp,Zp,IS,Elab=',A,Z,mp,Zp,IS,Elab
      Ecm=Elab*A/(mp+A)
      amu=mp*A/(mp+A)
      k  =sqrt(2.D0*mu*amu*Ecm)/hc
      eta=Zp* Z    *e2*mu*amu/(hc**2*k)
      write(0,*) 'Ecm,k,eta=',Ecm,k,eta
      call distwf(A,Z*Zp,amu,k,eta,nR,dR,Lmax,IS,chi)
      write(0,*) 'calculation done, now writing to files...'
      call cphase(Lmax,eta,sigma)
      do L=0,Lmax
         do J=abs(L-IS),L+IS
            JS=J-L
            write(0,*) 'L=',L,'  J=',J
            write(fmt,'(A,I1,A,I1,A)')
     &           '(A,I',int(log10(L+.9))+1,
     &           ',A,I',int(log10(J+.9))+1,',A)'
            write(flname,fmt) 'chi-',L,'-',J,'.dat'
            open(1,file=flname,status='unknown')
            write(1,'(2(A,I3))') '# L=',L,', J=',J
            write(1,'(0pF4.1,1p2E12.4)')
     &           (iR*dR,chi(iR,JS,L)*exp(dcmplx(0.D0,sigma(L))),iR=1,nR)
            close(1)
         enddo
      enddo
      end
