      implicit real*8(a-h,o-z)
      parameter (rmax=1., l=6, m=1, kmax=50)
      complex*16 Ylm1(0:(kmax+1)*(kmax+2))
      complex*16 Ylm2(0:(kmax+1)*(kmax+2))
      complex*16 Ylm (0:(kmax+1)*(kmax+2)),G,C
      real*8    H(0:kmax),f
      external  f
      pi=atan(1.D0)*4.D0
      call inirac
      do itry=1,10
         x1=rnduni(0.D0,rmax)
         y1=rnduni(0.D0,rmax)
         z1=rnduni(0.D0,rmax)
         x2=rnduni(0.D0,rmax)
         y2=rnduni(0.D0,rmax)
         z2=rnduni(0.D0,rmax)
         x =x1+x2
         y =y1+y2
         z =z1+z2
         r1=sqrt(x1*x1+y1*y1+z1*z1)
         t1=acos(z1/r1)
         p1=atan2(y1,x1)
         r2=sqrt(x2*x2+y2*y2+z2*z2)
         t2=acos(z2/r2)
         p2=atan2(y2,x2)
         r =sqrt(x *x +y *y +z *z )
         t =acos(z /r )
         p =atan2(y ,x )
         call spherical(t1,p1,kmax,Ylm1)
         call spherical(t2,p2,kmax,Ylm2)
         call spherical(t ,p ,kmax,Ylm )
         G=(0.D0,0.D0)
         do k2=0,kmax/2
            call expand(r1,r2,f,l,k2,H)
            do k1=abs(l-k2),l+k2,2
               C=0.D0
               do m1=-k1,k1
                  m2=m-m1
                  w=cleb(2*k1,2*m1,2*k2,2*m2,2*l,2*m)
                  if (w.ne.0.D0)
     &                 C=C+w*Ylm1(k1*(k1+1)+m1)*Ylm2(k2*(k2+1)+m2)
               enddo
               G=G+H(k1)*C*(-1)**((-l+k1+k2)/2)
            enddo
         enddo
         C=f(r)*Ylm(l*(l+1)+m)
         write(6,'(1HT,1p2E16.6/1HX,1p3E16.6/)') C,G,abs(G/C-1.D0)
      enddo
      end

      real*8 function f(r)
      implicit real*8(a-h,o-z)
c     f=1.D0
c     f=r**2
      f=exp(-r)-exp(-2.D0*r)
      return
      end

      real*8 function rnduni(lower,upper)
      implicit real*8(a-h,l,o-z)
      parameter (ip=250,iq=103,irbit=31,ilcbit=20,imask=2**(ilcbit-1))
      integer*4 ir(ip),irq(ip),inext(ip),ipos,ix
      logical*4 first,iniret
      data      ix/1048579/,first/.true./,iniret/.false./
      if (.not.first) goto 20000
10000 do i=1,ip
         ir (i)=0
         irq(i)=i-iq
         if (irq(i).lt.1) irq(i)=irq(i)+ip
         inext(i)=i+1
      enddo
      inext(ip)=1
      do i=1,irbit
         do j=1,ip
	    ix=ix*48828125
	    if (ix.le.0) ix=(ix+2147483647)+1
	    ir(j)=ir(j)*2+and(ix/imask,1)
         enddo
      enddo
      ipos=1
      first =.false.
      if (.not.iniret) goto 20000
      iniret=.false.
      return
20000 ir(ipos)=xor(ir(ipos),ir(irq(ipos)))
      rnduni=lower+(upper-lower)*float(ir(ipos))/2147483648.D0
      ipos=inext(ipos)
      return
      entry inirnd(iseed)
      ix=2*(iseed/2)+1
      iniret=.true.
      goto 10000
      entry endrnd()
      write(6,'(/A,I12)') 'Final Random-Seed =',ix
      return
      end
