#! /bin/sh

grep -v '^ *#' <<EOF | ../../accba
6Li(d,2He)6He[0+;Ex=0] @ 270MeV
  f  f  f             / DWBA,point-proj.,triple-diff.c.s.
  0  25  1            / thmin,thmax,dth
  6  3  1  0  270  -4.95  0  / A,ZA,IA,IB,Elab,Qval,Ex
 +1 1 1               / ptr,ntr,(jtr(i),i=1,ntr)
 150  0.1  70         / nRL,dRL,Lmax
  30  0.5   5  2  0   / nrs,drs,mrs,lamax,lbmax
  20  0.0  1.0        / nE12,E12min,E12max
# d-12C @ 270 MeV, Oonishi param.
 27.7  1.22  0.86  40.6  0.0 1.10  0.892 1.3 / dA: VR,rR,aR,WV,WD,rI,aI,rC
  3.81 0.71  0.68                            /     VLS,rLS,aLS
# p-6Li @ 144 MeV [Moake..., PR C21('80)25]
 16.96 1.110 0.713 10.78 0.0 1.000 0.855 1.12 / pB: VR,rR,aR,WV,WD,rI,aI,rC
# two-body effective interaction [Franey & Love, PRC 31('85)488-498, 140MeV]
# s t x r n (V(i),mu(i),i=1,n)! r:1=re,2=im, x:1=Yukawa,2=delta,3=r^2*Yukawa
  1 1 1 1 3  3.5  0.7143  257.05  2.5  -631.79  4.0 / real central direct
  1 1 1 2 2               132.37  2.5  -470.63  4.0 / imag central direct
  1 1 3 1 4  54.1158 1.429  -302.105 1.818  1706.87  2.5  -9194.06 4.0
  1 1 3 2 4  16.5249 1.429  -162.008 1.818   976.375 2.5  -5643.60 4.0
  1 1 2 1 1  -44.38  0 / real central exchange
  1 1 2 2 1   -3.53  0 / imag central exchange
 -1 /
# single-particle potential parameters
 1.25  0.65  6  1.3  / r0, a, VLS, r0C
# single-particle orbit definition
#'p0p3/2'   V   65.00   4.589 / orbit, search-param, V0, B.E.
#'p0p1/2'   E   64.588  0.3   / orbit, search-param, V0, B.E.
 'p0p3/2'   E   76.398  4.589 / orbit, search-param, V0, B.E.
 'p0p1/2'   V   64.588  4.589 / orbit, search-param, V0, B.E.
 'n0p3/2'   E   65.306  1.863 / orbit, search-param, V0, B.E.
 'n0p1/2'   V   50.00   1.863 / orbit, search-param, V0, B.E.
 'end' /
# spectroscopic-amplitude for p-h configurations
 'p0p3/2' 'n0p3/2' -0.33122  / hole, particle, spectroscopic amplitude
 'p0p3/2' 'n0p1/2' -0.32336  / hole, particle, spectroscopic amplitude
 'p0p1/2' 'n0p3/2'  0.34080  / hole, particle, spectroscopic amplitude
 'p0p1/2' 'n0p1/2' -0.05023  / hole, particle, spectroscopic amplitude
 'end' /
EOF
exit

# d-12C @ 270 MeV, Okamura(YS) param. #1
 20.65 1.378 0.785 30.37 0.0 1.093 0.869 1.3 / dA: VR,rR,aR,WV,WD,rI,aI,rC
  2.40 0.808 0.715                           /     VLS,rLS,aLS

# p-12C @ 134 MeV [Bauhoff..., NP A410('83)180]
 16.54 1.230 0.784 10.26 0.0 1.313 0.540 1.3 / pB: VR,rR,aR,WV,WD,rI,aI,rC

5He(3/2-)+p-6Li(1+)	5.012223628+1.007825032-6.015122281 = 4.588892480
5He(3/2-)+n-6He(0+)	5.012223628+1.008664923-6.018888072 = 1.863434186

 'p0p3/2' 'n0p3/2' -0.19123  / hole, particle, spectroscopic amplitude
 'p0p3/2' 'n0p1/2' -0.18669  / hole, particle, spectroscopic amplitude
 'p0p1/2' 'n0p3/2'  0.19676  / hole, particle, spectroscopic amplitude
 'p0p1/2' 'n0p1/2' -0.02900  / hole, particle, spectroscopic amplitude
