      REAL*8 FUNCTION TMAT2(S12,QC)
C     ENHANCEMENT-FACTOR OF P-P 1S0 BY MIGDAL-WATSON
      IMPLICIT REAL*8(A-H,K-M,O-Z)
      PARAMETER (PI=3.14159265358979, GAMMA=0.577215664901532,
     -           HC=197.32858, E2=1./137.03604, MY=938.2796, R=HC/E2/MY)
      DIMENSION QC(0:3)
      COMMON /SYSALL/MP,ZP,MT,ZT,M1,Z1,M2,Z2,M3,Z3
      COMMON /SYS12V/M0,M12,M23,P0L(0:3),
     -               P1L(0:3),P2L(0:3),P12L(0:3),P12C(0:3)
      LAMBDA(X,Y,Z)=X*(X-Y-Z)+Y*(Y-Z-X)+Z*(Z-X-Y)
      P1R12A=SQRT(LAMBDA((S12+M1+M2)**2,M1*M1,M2*M2))/2.D0/(S12+M1+M2)
      K=P1R12A/HC
      ETA=0.5D0/K/R
      IF (ETA.LT.1.D-10.OR.ETA.GT.80.) GOTO 90000
      RETA=2.D0*PI*ETA
      C2=RETA/(EXP(RETA)-1.D0)
      ETA2=ETA*ETA
      SIGMA=0.D0
      DO 10000 I=1,100
10000   SIGMA=SIGMA+1.D0/I/(I*I+ETA2)
      H=ETA2*SIGMA-LOG(ETA)-GAMMA
      D1=K*C2
      D2= 1./7.810-H/R+2.767/2.*K*K
      TMAT2=C2/(D1*D1+D2*D2)
      RETURN
90000 TMAT2=0.0
      RETURN
      END
