# Makefile for VMS/MMS(MMK)

PGM = [-]ACCBA$(EXE)

OBJS = ACCBA$(OBJ),RSCD$(OBJ),RSCK$(OBJ),DISTWF$(OBJ),ADIAWF$(OBJ),\
FFEXPD$(OBJ),FORMF$(OBJ),FFINT$(OBJ),SHELL$(OBJ),ORBIT$(OBJ),\
CPHASE$(OBJ),BESSEL$(OBJ),SPHERE$(OBJ),COULFG$(OBJ),RACAH$(OBJ),\
GAULEG$(OBJ),EXPAND$(OBJ),SPLINE$(OBJ),MATINV$(OBJ),AMP2CS$(OBJ)

ALL : $(PGM)

$(PGM) : $(OBJS)
	$(LINK)/EXECUTABLE=$(PGM) $(OBJS)

CLEAN :
	DELETE/LOG *$(OBJ);*,*.LIS;*

ALL.CLEAN : CLEAN
	DELETE/LOG $(PGM)

.SUFFIXES : .F

.F$(OBJ) :
	$(FORT)$(FFLAGS)/CHECK=NOPOWER $(MMS$SOURCE)

# /CHECK=NOPOWER is used to give 0.**0 => 1 ...

# The dependence on PARAMETER.F is not given, as I don't see how.  
# Type "mms clean" if PARAMETER.F is modified.  
