c     Exchange Interaction in a short-range approximation 
c
      implicit real*8(a-h,k,m,o-z)
      parameter (Tp=160.)
c     parameter (Tp= 30.)
      parameter (mu=931.501, mp=1.008665*mu, hc=197.329)
      real*8 Vt(2),V(3,2),R(3,2)
      data   Vt/2*0./
      data   V /
c     Franey-Love 140MeV V_sigma_tau interaction, real & imag.
c    -	   -1297.15,  355.34,   -0.87 ,  -888.25,  310.34,    0.  / ! st
c     Franey-Love 140MeV V_tau interaction, real & imag.
     -	   -2158.44,  531.48,    2.625, -1664.75,  583.65,    0.  / ! t
c     M3Y V_sigma_tau & V_tau
c    -	   -3788.88,  827.13,   -0.87,-1517.88,  828.38,    2.62/
      data   R /
     -	       0.25,    0.40,    1.40,    0.25,    0.40,    1.40/
      pi=atan(1.D0)*4.D0
      p=sqrt((Tp+mp)**2-mp**2)
      k=p/hc
      write(6,*) 'p,k=',p,k
      do j=1,2
         do i=1,3
	    Vt(j)=Vt(j)+4.D0*pi*V(i,j)*R(i,j)**3/(1.D0+(k*R(i,j))**2)
         enddo
      enddo
      write(6,*) (Vt(j),j=1,2)
      stop
      end
